: '@(#)$Id: MH.6.6.0.sh,v 1.5 90/04/08 13:47:44 sources Exp $'

if [ ! -d uip ]; then
    echo "Sorry, this script must be run from the mh-6 top-level directory"
    exit 1
fi

cat <<EOF

This script is the first part of the update from MH 6.6 to MH 6.7.
You must have an unmodified mh-6.6 source tree to guarantee these
updates will have no errors.

This script will create some directories, rename some files which will
be installed with the subsequent patches, and remove some files which
are unused in this release.  After this script completes, your MH
distribution will be at Patchlevel:

	MH.6.6 patch.0

Do you want to backup the files which will be removed, into a tar file?
EOF
echo 'Enter "y" to backup the files, or press RETURN to continue:'
read A
case x$A in
  xy*) 
    FILES=""
    for d in bboards mh4 mh5 multifarious realwork trusted tutorial
    do
	for f in article.tex dcustom.tex sfwmac.tex trademark.tex diss.sty
	do
	    FILES="${FILES} papers/$d/$f"
	done
    done
    for f in version.c version.local version.major version.minor version.sh
    do
	FILES="${FILES} uip/$f"
    done
    echo "Creating backup.tar"
    tar cvf backup.tar ${FILES}
  ;;
  *) ;;
esac


if [ ! -f Patchlevel ]; then
: This is a shar archive.  Extract with sh, not csh.
: This archive ends with exit, so do not worry about trailing junk.
echo 'Extracting Patchlevel'
sed 's/^X//' > Patchlevel << '+ END-OF-FILE Patchlevel'
XMH.6.6 patch.0
+ END-OF-FILE Patchlevel
chmod 'u=rw,g=r,o=r' 'Patchlevel'
echo '	-rw-r--r--  1 sources        15 Apr  6 13:54 Patchlevel        (as sent)'
echo -n '	'
/bin/ls -l Patchlevel
fi

echo "Checking Patchlevel"
if grep -s '^MH.6.6 patch.0$' Patchlevel; then
    echo "Good, you're at Patchlevel `cat Patchlevel`."
else
    echo "Oops! You're at Patchlevel `cat Patchlevel`.
Aborting"
    exit 1
fi

if [ ! -d papers/doclib ]; then
    echo "Making papers/doclib/"
    mkdir papers/doclib
fi
if [ ! -d papers/mh6.7 ]; then
    echo "Making papers/mh6.7/"
    mkdir papers/mh6.7
fi

echo "Moving TeX library files"
for f in article.tex dcustom.tex diss.sty trademark.tex
do
    if [ -f papers/trusted/$f ]; then
	rm -f papers/doclib/$f
	echo cp papers/trusted/$f papers/doclib/$f
	cp papers/trusted/$f papers/doclib/$f
	ls -l papers/doclib/$f
    fi
done

echo "Renaming files"
for f in READ-ME conf/doc/mh-format.rf h/fmtcompile.h \
	 sbr/m_seq.c zotnet/tws/lexstring.c uip/sortm.c
do
    if [ -f ${f} ]; then
	rm -f ${f}.old
	echo mv ${f} ${f}.old
	mv ${f} ${f}.old
	ls -l ${f}.old
    fi
done

echo "Removing old TeX library files"
for d in bboards mh4 mh5 multifarious realwork trusted tutorial
do
    for f in article.tex dcustom.tex sfwmac.tex trademark.tex diss.sty
    do
	echo "rm -f papers/$d/$f"
	rm -f papers/$d/$f
    done
done

echo "Removing old uip/version files"
for f in version.c version.local version.major version.minor version.sh
do
    echo "rm -f uip/$f"
    rm -f uip/$f
done


cat <<EOF
Done.

You should now apply each of the patches in numerical order.  Be sure
you are at the mh top-level directory, and execute patch as:

	patch -p < MH.6.6.n

EOF
exit 0
